LeetCode 465. Optimal Account Balancing 互相结账 回溯 组合

A group of friends went on holiday and sometimes lent each other money. For example, Alice paid for Bill's lunch for $10. Then later Chris gave Alice $5 for a taxi ride. We can model each transaction as a tuple (x, y, z) which means person x gave person y $z. Assuming Alice, Bill, and Chris are person 0, 1, and 2 respectively (0, 1, 2 are the person's ID), the transactions can be represented as [[0, 1, 10], [2, 0, 5]].

Given a list of transactions between a group of people, return the minimum number of transactions required to settle the debt.

Note:

  1. A transaction will be given as a tuple (x, y, z). Note that x ≠ y and z > 0.
  2. Person's IDs may not be linear, e.g. we could have the persons 0, 1, 2 or we could also have the persons 0, 2, 6.

 

Example 1:

Input:
[[0,1,10], [2,0,5]]

Output:
2

Explanation:
Person #0 gave person #1 $10.
Person #2 gave person #0 $5.

Two transactions are needed. One way to settle the debt is person #1 pays person #0 and #2 $5 each.

 

Example 2:

Input:
[[0,1,10], [1,0,1], [1,2,5], [2,0,5]]

Output:
1

Explanation:
Person #0 gave person #1 $10.
Person #1 gave person #0 $1.
Person #1 gave person #2 $5.
Person #2 gave person #0 $5.

Therefore, person #1 only need to give person #0 $4, and all debt is settled.

 

Accepted

32,715

Submissions

70,489

--------------------------------------------------------------------

思路一:非常好的一道题目,直接的解法就是回溯。A总算账多钱,B总算账少钱;或者A总算账少钱,B总算账多钱。可以通过B把A的帐清了,A就回溯完了,B和其他人的账号后面dfs再算。。。

class Solution {
public:
    int minTransfers(vector<vector<int>>& transactions) {
        int res = INT_MAX;
        unordered_map<int, int> m;
        for (auto t : transactions) {
            m[t[0]] -= t[2];
            m[t[1]] += t[2];
        }
        vector<int> accnt;
        for (auto a : m) {
            if (a.second != 0) accnt.push_back(a.second);
        }
        helper(accnt, 0, 0, res);
        return res;
    }
    void helper(vector<int>& accnt, int start, int cnt, int& res) {
        int n = accnt.size();
        while (start < n && accnt[start] == 0) ++start;
        if (cnt >= res) {
            return;
        }
        if (start == n) {
            res = min(res, cnt);
            return;
        }
        for (int i = start + 1; i < n; ++i) {
            if ((accnt[i] < 0 && accnt[start] > 0) || (accnt[i] > 0 && accnt[start] < 0)) {
                accnt[i] += accnt[start];
                helper(accnt, start + 1, cnt + 1, res);
                accnt[i] -= accnt[start];
            }
        }
    }
};

思路二:最差情况下,所有人总算账都要付钱或者拿钱,家里打麻将结账就是这么算钱的,每个人考虑自己的多少,把钱扔到公共的buffer里,这是人的总数N。如果这N个中最多包含m个和为0的子团(m肯定至少为1呀),那么最终结果就是N-m。这个问题还可以从另外一个角度去想:假设有10个人,5个人是一团为0,需要4,另外5个人一团为0,也需要4,每出现一个团就可能为最终结果-1。所以问题就变成了求m,动态规划就可以了,当然这个动态规划的递推逻辑并不容易想。

注意这里组合数遍历的方式和24点(https://blog.csdn.net/taoqick/article/details/23393487)的方式不同:

from collections import defaultdict
class Solution:
    def minTransfers(self, transactions):
        money = defaultdict(int)
        for sender, receiver, amount in transactions:
            money[sender] -= amount
            money[receiver] += amount

        amounts = [amount for amount in money.values() if amount != 0]
        N = len(amounts)
        dp = [0] * (2 ** N)  #dp[i]表示最多以组合i的结果最多包含几个和为0的团
        sums = [0] * (2 ** N)  # sums[i]表示以组合i的结果累加和是多少

        for mask in range(2 ** N):
            set_bit = 1
            for b in range(N):
                if mask & set_bit == 0:
                    nxt = mask | set_bit
                    sums[nxt] = sums[mask] + amounts[b]
                    if sums[nxt] == 0:
                        dp[nxt] = max(dp[nxt], dp[mask] + 1)
                    else:
                        dp[nxt] = max(dp[nxt], dp[mask])
                set_bit <<= 1
        return N - dp[-1]

s = Solution()
print(s.minTransfers([[0,1,5], [0,2,6], [0,3,6]]))

 

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章